# Diffusion Bee - Stable Diffusion GUI App for MacOS
[![Twitter](https://img.shields.io/twitter/url.svg?label=Follow%20%40divamgupta&style=social&url=https%3A%2F%2Ftwitter.com%2Fdivamgupta)](https://twitter.com/divamgupta)



### Diffusion Bee is the easiest way to run Stable Diffusion locally on your Intel / M1 Mac. Comes with a one-click installer. No dependencies or technical knowledge needed.

* Runs locally on your computer no data is sent to the cloud ( other than request to download the weights or unless you chose to upload an image ).
*  *If you like Diffusion Bee, consider checking https://Liner.ai , a one-click tool to train machine learning models*

<br>

[![Download](https://user-images.githubusercontent.com/1890549/189538422-52d50488-c1fa-4924-bec6-186c9e0f307b.png)](https://diffusionbee.com/)

Download at https://diffusionbee.com/


<br>

For prompt ideas visit https://arthub.ai

Join discord server : https://discord.gg/t6rC5RaJQn


## Features
* Full data privacy - nothing is sent to the cloud ( unless you chose to upload an image )
* Clean and easy to use UI with one-click installer
* Image to image
* Supported models : - SD 1.x, SD 2.x, SD XL, Inpainting, ControlNet, LoRA
* Download models from the app
* In-painting
* Out-painting
* Generation history
* Upscaling images
* Multiple image sizes
* Optimized for M1/M2 Chips
* Runs locally on your computer
* Negative prompts
* Advanced prompt options
* ControlNet


## How to use 

1) Download and start the application

![image](https://user-images.githubusercontent.com/1890549/198916443-c6a2e40a-3d1e-4000-882d-993aa1941391.png)


2) Enter a prompt and click generate

Text to image:

![Screenshot 2023-12-13 at 1 19 38 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/3ee8e70b-ea17-4b26-8069-6d8c65aaa729)



Image to image:

![Screenshot 2023-12-13 at 1 14 35 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/ceb4b799-5003-47c6-a689-1a5dcd110935)

Multiple Apps:

![Screenshot 2023-12-13 at 1 11 14 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/5deb2129-b1c7-4f25-9718-754aa9a96008)


Image to image with mask:

![image](https://user-images.githubusercontent.com/1890549/198915075-dba8e90f-47f6-4915-87b5-fd09c17a58e5.png)

Inpainting:

![image](https://user-images.githubusercontent.com/1890549/198915349-6261dc9e-c24d-4fb0-98a2-973b429914b8.png)

![image](https://user-images.githubusercontent.com/1890549/198915395-71d4d278-2434-4e21-aea6-42988593941a.png)

Advanced AI Canvas:

![Screenshot 2023-12-13 at 1 13 59 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/f01273d3-6a01-4498-8d11-5f46b9946213)


![image](https://user-images.githubusercontent.com/1890549/198916091-62872915-af1d-4553-b657-934c1c8c7aca.png)

ControlNet:

![Screenshot 2023-12-13 at 1 12 43 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/55f8d6b0-2f18-4706-9771-999f379a8e4d)

![Screenshot 2023-12-13 at 1 12 22 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/53f5e3ef-6398-4c43-aeb6-0f1ded052a9a)


Download Models:

![Screenshot 2023-12-13 at 1 13 08 PM](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/assets/1890549/4202ba4e-f33f-47e7-bd27-26b1b93142db)


History:

![image](https://user-images.githubusercontent.com/1890549/198916678-9061829c-69da-4eee-b28d-1989e01c11e0.png)


### To learn more, visit the [documentation](https://github.com/divamgupta/diffusionbee-stable-diffusion-ui/blob/master/docs/DOCUMENTATION.md).

## Requirements 
* Mac with Intel or M1/M2 CPU
* For Intel : MacOS 12.3.1 or later 
* For M1/M2 : MacOS 11.0.0 or later 

License : Stable Diffusion is released under the CreativeML OpenRAIL M license : https://github.com/CompVis/stable-diffusion/blob/main/LICENSE
Diffusion Bee is just a GUI wrapper on top of Stable Diffusion, so all the term of Stable Diffusion are applied on the outputs. 



References
1) https://github.com/CompVis/stable-diffusion
2) https://github.com/madebyollin/maple-diffusion
3) https://github.com/divamgupta/stable-diffusion-tensorflow
4) https://github.com/liuliu/swift-diffusion (big thanks to Liu Liu)
5) https://github.com/huggingface/diffusers

 
